/*
 * Copyright (c) 2014 - Zephyr Software LLC
 *
 * This file may be used and modified for non-commercial purposes as long as
 * all copyright, permission, and nonwarranty notices are preserved.
 * Redistribution is prohibited without prior written consent from Zephyr
 * Software.
 *
 * Please contact the authors for restrictions applying to commercial use.
 *
 * THIS SOURCE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * Author: Zephyr Software
 * e-mail: jwd@zephyr-software.com
 * URL   : http://www.zephyr-software.com/
 *
 */

#include <stdint.h>
#include <strlen.h>


#define MAX_ENTRIES 4096

uintptr_t ret_shadow_stack[MAX_ENTRIES];
int rss_head_pointer=0;

static void print_stack(char* s)
{
#ifdef DEBUG
	write(1,s,strlen(s));
	s=": rss_head_pointer=";
	write(1,s,strlen(s));
	char rss_head_str[2*sizeof(void*)+1];
	itox(rss_head_pointer,rss_head_str);
	write(1,rss_head_str,strlen(rss_head_str));
	write(1,"\n",1);
	int i;
	for(i=0;i<rss_head_pointer;i++)
	{
		char i_str[2*sizeof(void*)+1];
		char entry_str[2*sizeof(void*)+1];
		itox(i,i_str);
		itox(ret_shadow_stack[i],entry_str);
		write(1,i_str,strlen(i_str));
		write(1,",",1);
		write(1,entry_str,strlen(entry_str));
		write(1,"\n",1);
		
	}
#endif
}

void zipr_push_stack(uintptr_t app_ret_addr, uintptr_t stack_ret_addr)
{
#ifdef DEBUG
	char appret[2*sizeof(void*)+1];
	char stackret[2*sizeof(void*)+1];
	itox(app_ret_addr,appret);
	itox(stack_ret_addr,stackret);
	char str[]="zipr_push_callback, appret,stackret=";
	write(1,str,sizeof(str));
	write(1,appret,sizeof(appret));
	write(1,",",1);
	write(1,stackret,sizeof(stackret));
	write(1,"\n",1);

	print_stack("push");
#endif
	ret_shadow_stack[rss_head_pointer++]=stack_ret_addr;
}

void zipr_pop_stack(uintptr_t app_ret_addr, uintptr_t stack_ret_addr)
{
#ifdef DEBUG
	char appret[2*sizeof(void*)+1];
	char stackret[2*sizeof(void*)+1];
	itox(app_ret_addr,appret);
	itox(stack_ret_addr,stackret);
	char str[]="zipr_pop_callback, appret,stackret=";
	write(1,str,sizeof(str));
	write(1,appret,sizeof(appret));
	write(1,",",1);
	write(1,stackret,sizeof(stackret));
	write(1,"\n",1);
	print_stack("pop");
#endif

	if(ret_shadow_stack[--rss_head_pointer]!=stack_ret_addr)
		*(int*)(0)=0;
	

}
